//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.action;

//===========================================================================
// import
//===========================================================================
import java.io.IOException;
import java.util.Locale;
import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.commons.logging.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;
import org.apache.commons.beanutils.*;

import java.util.*;
import jp.gr.java_conf.bugslife.user.*;
import jp.gr.java_conf.bugslife.selections.*;
import jp.gr.java_conf.bugslife.form.*;
/**
 *<PRE>
 * 
 * SysconfEditActionクラス
 *
 *</PRE>
 * @version	0.0
 * @author	鰐川 正寛
 */
public final class SysconfEditAction extends BaseAction 
{
//===========================================================================
// attributes
//===========================================================================
	/**
	 * Log
	 */
	private Log log = LogFactory.getLog(this.getClass().getName());
//===========================================================================
// methods
//===========================================================================
	/**
	 * exevute
	 *
	 * @param mapping The ActionMapping used to select this instance
	 * @param actionForm The optional ActionForm bean for this request (if any)
	 * @param request The HTTP request we are processing
	 * @param response The HTTP response we are creating
	 *
	 * @exception Exception if business logic throws an exception
	 */
	public ActionForward doAction(ActionMapping mapping,
				 ActionForm form,
				 HttpServletRequest request,
				 HttpServletResponse response)
				throws Exception {
		/*  初期処理
		 */
		HttpSession session = getSession(request);	//sessioの取得
		UserInfo logonUser = (UserInfo)getAttribute(session,"UserInfo");	//ログインユーザの取得
		ActionForward forward = null;
		SysconfEditForm myForm = (SysconfEditForm)form;
		
		String action = myForm.getAction();
		
		
		//表示
		if (action.equals("show")) {
			
			Sysconf sysconf = Sysconf.getSysconf();

			PropertyUtils.copyProperties(myForm, sysconf);		//コピー
			
			if (sysconf.getDisableMail() == Sysconf.ENABLE_MAIL) {
				myForm.setDisableMail2(false);
			}
			else if (sysconf.getDisableMail() == Sysconf.DISABLE_MAIL) {
				myForm.setDisableMail2(true);
			}
			forward = mapping.findForward("show");		
		//更新
		} else {
			
			//データチェック
			ActionErrors errors = myForm.validate(mapping, request);
			if (!errors.empty()) {
				saveErrors(request, errors);
				return (new ActionForward(mapping.getInput()));
			}
			Sysconf sysconf = Sysconf.getSysconf();
			
			if (myForm.m_disableMail2) {
				sysconf.setDisableMail(Sysconf.DISABLE_MAIL);
			}
			else if (!myForm.m_disableMail2) {
				sysconf.setDisableMail(Sysconf.ENABLE_MAIL);
			}
			
			PropertyUtils.copyProperties(sysconf, myForm);	//コピー
			sysconf.update(logonUser.getUno());
			
			SelectionSet.setSysconf(session.getServletContext(), true);
						
			forward =  mapping.findForward("success");
		}
			
		// Forward control to the specified success URI
		return forward;
		
	}
}
